% Dieses Dokument ist in der Zusammenarbeit von Informatikreferendaren und
% ehemaligen Informatikreferendaren der Studienseminare (heute ZfsL) Arnsberg,
% Hamm und Solingen entstanden.
%
% Das Dokument steht unter der Lizenz: Creative Commons by-nc-sa Version 4.0
% http://creativecommons.org/licenses/by-nc-sa/4.0/deed.de
%
% Nach dieser Lizenz darf das Dokument beliebig kopiert und bearbeitet werden,
% sofern das Folgeprodukt wiederum unter gleichen Lizenzbedingungen vertrieben
% und auf die ursprünglichen Urheber verwiesen wird.
% Eine kommerzielle Nutzung ist ausdrücklich ausgeschlossen.
%
% Die Namensnennung durch einen Verweis und die Lizenzangabe der ursprünglichen
% Urheber auf den Materialien für Schülerinnen und Schüler ist erforderlich.
%
% Die Sammlung der Dokumente steht unter
% http://ddi.uni-wuppertal.de/material/materialsammlung/
% zur Verfügung.
%
% Das LaTeX-Paket zum Setzen der Dokumente der Sammlung steht
% unter  http://www.ctan.org/pkg/schule
% zur Verfügung.

\svnid{$Id: kap2.inc 1202 2015-04-28 15:15:46Z humbert $}

\chapter{Der erste Baum}
\begin{Uebersicht}
In diesem Kapitel dreht sich alles darum, aus den Ergebnissen der binären Suche eine neue Datenstruktur zu konzipieren, die deren Vorteile in sich beinhaltet.
\end{Uebersicht}
\begin{Lernziele}
Nach Bearbeitung dieses Kapitels
\begin{itemize*}
 \item können Sie die Eigenschaften eines binären Suchbaums und dessen einzelnen Bestandteile benennen.
 \item können Sie einen binären Baum auf eine bestimmte Art und Weise durchlaufen.
\end{itemize*}
\end{Lernziele}
\section{Wir entwerfen eine neue Datenstruktur}
Nachdem Sie im letzten Kapitel das Prinzip der \enquote{Binären Suche} kennengelernt haben, soll es in diesem Kapitel darum gehen, eine Datenstruktur zu entwickeln, die die Vorteile der binären Suche ausnutzt. Der Einfachheit halber arbeiten wir an dieser Stelle zuerst nur mit einer Menge von Zahlen. Generell lässt sich dieses Prinzip aber auf jede beliebige Art von Elementen übertragen -- \underbar{vorausgesetzt,} dass die Elemente auf irgendeine Art und Weise miteinander vergleichbar sind (oder mathematisch ausgedrückt: einer Ordnungsrelation unterliegen). Wenn das Prinzip soweit klar ist, werden wir uns wieder unserer CD-Sammlung zuwenden.

Das Problem an der linearen Liste ist, dass die Zahlen nach wie vor darin nur in aufsteigend sortierter Reihenfolge vorliegen, ein direkter Zugriff auf die Elemente aber so, wie wir sie in der binären Suche benötigen, nicht möglich ist. Was liegt also näher, als eine neue Datenstruktur zu entwickeln, die die Vorteile der Suche nach einem bestimmten Element schon bei ihrem Aufbau berücksichtigt und so die Suchanfragen minimiert.

Damit wollen wir uns auf den folgenden Seiten beschäftigen.\\
\begin{Aufgabe}
  Gegeben ist die Liste der Zahlen von 1 bis 9 in aufsteigender Reihenfolge:
  \begin{center}
    1, 2, 3, 4, 5, 6, 7, 8, 9.
  \end{center}
  \begin{enumerate}[(a)]
  \item Wenden Sie die binäre Suche an, um das Element 2 in der Liste zu finden. Notieren Sie dabei wiederum jede Zahl, die Sie betrachten. Verfahren Sie ebenso mit der Zahl 9.

    \underbar{Erinnerung:} Betrachten wir eine ungerade Zahl von Elementen, runden wir das Ergebnis für die Mitte auf!
  \item Überlegen Sie eine Möglichkeit, Ihr Ergebnis und der Weg, den Sie von Element zu Element gegangen sind, graphisch in \underbar{einer} Zeichnung darzustellen. Beachten Sie dabei auch, in welche \enquote{Richtung} Sie sich von Element zu Element bewegt haben. Vervollständigen Sie diese Zeichnung so, dass die Suche nach allen Elementen (also auch nach der 1,3,4,\ldots) daraus abgelesen werden kann. (Schauen Sie nach dieser Aufgabe noch \underbar{nicht} in die Lösungen, sondern bearbeiten Sie erst Aufgabe (c).)
  \item Zeichnen Sie Ihre Idee auf ein DIN A4-Blatt und vergleichen Sie diese mit einem Partner. Versuchen sie, ihre Ideen zu kombinieren, dass eine sinnvolle Darstellung entsteht.
  \end{enumerate}
\end{Aufgabe}
Sollten Sie mit der Aufgabe nicht klarkommen, können Sie sich im Kasten unten eine Anregung holen.\\
\begin{Nothelfer}
  \begin{enumerate}
  \item Mit welchem der Elemente beginnt Ihre Suche \underbar{immer}? Dieses Element sollte in Ihrer Darstellung oben stehen.
  \item Wie viele Möglichkeiten haben Sie, um von einem Element zum nächsten zu gelangen? Zeichnen Sie die möglichen nachfolgenden Elemente unterhalb des aktuellen Elements und beachten Sie dabei die \enquote{Richtung}, in die Sich sich auf sie zu bewegst.
  \end{enumerate}
\end{Nothelfer}
\section{Der binäre Suchbaum}
Die untenstehende Darstellung zeigt Ihnen einen sogenannten \textbf{binären Suchbaum}.
\begin{center}
  \begin{tikzpicture}[level distance=13mm, level/.style={sibling distance=24mm/#1}, every node/.style={draw,circle,fill=white}]
\node[circle, draw] (root) {5}
  child {node {3}
    child {node {2}
      child {node {1}}
      child[missing] {node {x}}
      }
    child {node {4}}
    }
  child {node {8}
    child {node {7}
      child {node {6}}
      child[missing] {node {x}}
    }
    child {node {9}}
  };
  \end{tikzpicture}
\end{center}
 Der binäre Suchbaum ist aus den einzelnen Suchanfragen entstanden und zeichnet den Weg nach, den wir bei der Suche nach einem bestimmten Element zurückgelegt haben. Haben wir beispielsweise nach dem Element \tikz{\node[draw, circle]{\footnotesize 6};} gesucht, so wurde dabei der folgende Weg zurückgelegt:
 \begin{center}
   \begin{tikzpicture}[every node/.style={draw,circle,node distance=1.5cm}]
     \node (f) {5};
     \node[right of=f] (a) {8};
     \node[right of=a] (si) {7};
     \node[right of=si,thick] (se) {6};

     \path[draw,] (f) -- (a) -- (si) -- (se);
   \end{tikzpicture}
 \end{center}
\begin{Theorie}
  Bäume sind eine der wichtigsten dynamischen Datenstrukturen in der Informatik. Bevor wir auf weiterführende Eigenschaften der Bäume zu sprechen kommen, folgen zuerst einige grundlegende Definitionen:
  \begin{itemize}
  \item Die Elemente, aus denen ein Baum besteht, werden \textbf{Knoten} genannt. Der oberste Knoten in einem Baum heißt \textbf{Wurzel}\footnote{Dies entspricht nicht unbedingt der Intuition, da die Wurzel in unseren Bäumen immer oben ist. Man kann sich den Begriff leichter merken, wenn man sich klarmacht, dass alle anderen Knoten an der Wurzel \enquote{hängen}.}.
  \item Die Verbindungslinien zwischen zwei Knoten heißen \textbf{Kanten}.
  \item Da es sich bei unserem Suchbaum um einen \emph{binären} Baum\footnote{Erinnern Sie sich daran, woher der Begriff \enquote{Binäre Suche} stammt.} handelt, kann ein Knoten \textbf{maximal zwei} direkte Nachfolger haben. Knoten, die keinen Nachfolger haben, nennt man \textbf{Blatt}.
  \item Die \textbf{Höhe} eines Baums ist definiert als der längste Weg von der Wurzel zu einem Blatt. Wir bewegen uns dabei von oben nach unten entlang der Kanten. Im obigen Beispiel hat der Baum eine Höhe von $h=4$.
  \end{itemize}
Binäre Suchbäume dienen u.\,a. dazu, Daten (vor allem Daten, die sich häufig verändern) aufzunehmen und zu speichern. Durch ihre Struktur (auf die wir später noch genauer zu sprechen kommen werden), lassen sich Bäume effizient nach bestimmten Daten durchsuchen.
\end{Theorie}
Es gibt viele verschiedene Arten von Bäumen in der Informatik, wir beschäftigen uns im Rahmen dieses Leitprogramms aber überwiegend mit den binären Suchbäumen. Warum dieser Baum \enquote{binärer} Baum heißt, haben wir uns bereits verdeutlicht. Im Folgenden wollen wir einige Eigenschaften untersuchen, die binäre Suchbäume für uns interessant machen.
\section{Eigenschaften des binären Suchbaums}
\label{eigBinBaum}
Bevor wir uns mit der elementarsten Eigenschaft des binären Suchbaums befassen können, benötigen wir eine weitere Definition: Den sogenannten Teilbaum.
\begin{center}
  \begin{tikzpicture}[level distance=13mm, level/.style={sibling distance=30mm/#1}, every node/.style={draw,circle,fill=white}]
    \node[circle, draw] (root) {5}
    child {node[draw=red] {3}
      child {node[draw=red] {2}
        child {node[draw=red] {1}}
        child[missing] {node {x}}
      }
      child {node[draw=red] {4}}
    }
    child {node {8}
      child {node[draw=blue] {7}
        child {node[draw=blue] {6}}
        child[missing] {node {x}}
      }
      child {node {9}}
    };
    \begin{pgfonlayer}{background}
      \node[draw=red,rectangle,rounded corners,fill=yellow!20, fit=(root-1) (root-1-1) (root-1-2) (root-1-1-1)] {};
      \node[draw=blue,rectangle,rounded corners,fill=blue!20, fit=(root-2-1) (root-2-1-1)] {};
    \end{pgfonlayer}
  \end{tikzpicture}
\end{center}
Ein \textbf{Teilbaum} eines binären Suchbaums sind alle Knoten, die von einem bestimmten Knoten aus erreichbar sind. Im Beispiel sind zwei solche Teilbäume eingezeichnet. Den obersten Knoten dieser Teilbäume nennen wir ebenfalls \textbf{Wurzel}, diesmal jedoch die Wurzel eines Teilbaums. Zusätzlich unterscheiden wir zwischen einem \textbf{linken} und einem \textbf{rechten} Teilbaum: Im oberen Beispiel ist der linke Teilbaum von 3 der Teilbaum mit den Knoten 1 und 2, der rechte Teilbaum ist der Knoten 4. Enthält ein Teilbaum keine Knoten, bezeichnen wir ihn als \textbf{leer}.

Es folgen einige Aufgaben, mit denen Sie Ihr Verständnis für den Begriff des Teilbaums überprüfen können.\\
\begin{Aufgabe}
  \begin{enumerate}[(a)]
  \item Aus welchen Knoten besteht der Teilbaum mit der Wurzel 8?
  \item Welche Knoten gehören zum linken, welche zum rechten Teilbaum des blau eingezeichneten Teilbaums?
  \item Ist der Teilbaum mit einem Blatt als Wurzel ebenfalls ein Teilbaum?
  %\item Ein Knoten kann maximal von zwei verschiedenen Teilbäumen die Wurzel sein. Nehmen Sie Stellung.
  \end{enumerate}
\end{Aufgabe}
Im Folgenden wollen wir eine Eigenschaft untersuchen, die besonders im Hinblick darauf wichtig ist, wenn wir unseren Suchbaum \enquote{von Grund auf aufbauen} oder Elemente in den Baum einfügen wollen, ohne seine leichte Durchsuchbarkeit direkt zu zerstören. Bearbeiten Sie hierzu folgende Aufgabe:\\
\begin{Aufgabe}
  Betrachten Sie einen beliebigen Teilbaum mit der Wurzel $w$. Welche elementare Eigenschaft fällt Ihnen auf, wenn Sie die Werte innerhalb der Knoten miteinander vergleichen? Begründen Sie dies!
\end{Aufgabe}
\begin{Nothelfer}
  Betrachen Sie zuerst einen einzelnen Knoten und dessen linken und rechten Nachfolger. Welche Relation besteht zwischen diesem Knoten und seinen Nachfolgern? Versuchen Sie anschließend, Ihr Ergebnis auf Teilbäume auszuweiten.
\end{Nothelfer}
\section{Wo ist die Ordnung hin?}
Nach den ziemlich theoretischen letzten Abschnitten kehren wir nun wieder etwas mehr zur konkreten Anwendung zurück.

Wir erinnern uns: Unser erster binärer Suchbaum ist als Produkt aus der binären Suche entstanden, indem wir die Reihenfolge der besuchten Elemente in eine graphische Darstellung gebracht haben. Das würde allerdings bedeuten, dass wir, um einen Baum aufzubauen, immer zuerst eine sortierte Menge von Elementen benötigen, auf die wir dann einzeln die binäre Suche anwenden, um unseren Baum Knoten um Knoten aufzubauen. Das klingt insgesamt nicht sehr effizient und nutzt auch nicht die Vorteile aus, die der Baum als Datenstruktur hat. Unser Ziel sollte es also sein, einen Baum durch die Vorgabe einer Menge von Elementen so aufbauen zu können, dass die Eigenschaft aus Abschnitt \ref{eigBinBaum} erfüllt bleibt. Und natürlich sollte unser Baum ebenfalls die Möglichkeit haben, die in ihm abgelegten Elemente auch wieder in der richtigen Reihenfolge ausgeben zu können -- denn wenn man einen Baum an sich betrachtet, ist es nicht unbedingt direkt möglich, zu sagen, in welche Reihenfolge die Elemente ausgegeben werden müssen.

Den Aspekt des Aufbaus verschieben wir nun vorerst auf das nächste Kapitel und beschäftigen uns hier mit dem sogenannten \enquote{Baumdurchlauf} und welche Möglichkeiten es hierfür gibt. Hierzu betrachten wir folgenden Baum mit einigen der Interpreten aus Ihrer CD-Sammlung:
\begin{center}
  \footnotesize
\begin{tikzpicture}[level distance=1.8cm, 
		    level/.style={sibling distance=7cm/#1},
		    every node/.style={draw,ellipse,fill=white,text width=1.8cm, minimum height=.9cm, text centered}]
\node (root) {Ivy Quainoo}
  child {node {David Guetta}
    child {node {Boy}
      child {node {AC/DC}}
      child[missing] {node {x}}
    }
    child {node {Eisblume}}
  }
  child {node {Rihanna}
    child {node {Michel Telo}
      child {node {Lana Del Rey}}
      child[missing] {node {x}}
    }
    child {node {The Overtones}
      child {node {Silbermond}}
      child[missing] {node {x}}
    }
  };
\end{tikzpicture}
\end{center}
Wie Sie sich sicher schnell vergewissern können, ist die Eigenschaft aus Abschnitt \ref{eigBinBaum} auch für diesen Baum erfüllt. Wie wollen uns nun einen Algorithmus überlegen, nach dem man vorgehen kann, um die Elemente in sortierter Reihenfolge aus dem Baum abzulesen.\\
\begin{Aufgabe}
  Entwickeln Sie einen Algorithmus in Umgangssprache, der den Baum in der richtigen Reihenfolge wieder ausgibt.
\end{Aufgabe}
Im unteren Kasten sind einige Fragen aufgelistet, die Ihnen Anhaltspunkte liefern können, worauf Sie bei der Formulierung achten müssen.\\
\begin{Nothelfer}
  \begin{itemize}
  \item Welches Element ist das erste in der Liste? Welchen Weg müssen Sie zurücklegen, um dieses Element zu erreichen? Danken Sie dabei immer an die in \ref{eigBinBaum} festgestellte Eigenschaft!
  \item Betrachten Sie den Teilbaum mit \enquote{David Guetta} als Wurzel. Bewegen Sie sich nun entlang der Kanten zum ersten Element, danach zum zweiten usw.. Was sagt dies über die Reihenfolge aus, die Sie bei der Ausgabe beachten mussten?
  \item Versuchen Sie bei Ihrem Algorithmus die Teilbäume eines Knotens in Betracht zu ziehen. Welchen der Teilbäume müssen Sie zuerst bearbeiten?
  \end{itemize}
\end{Nothelfer}

Diesen Algorithmus nennt man \emph{Inorder-Durchlauf}, da er die Knoten in der richtigen Reihenfolge (also \enquote{in order} ausgibt).\\
\newpage
\begin{Lernkontrolle}
  Gegeben ist folgender binärer Baum:
  \begin{center}
    \begin{tikzpicture}[level distance=1.1cm, 
      level/.style={sibling distance=5cm/#1},
      every node/.style={draw,circle,fill=white, text centered}]
      \node (root) {a}
      child {node {b}
        child {node {d}
          child {node {h}}
          child {node {i}}
        }
        child {node {e}}
      }
      child {node {c}
        child {node {f}
          child[missing] {node {x}}
      child {node {j}}
    }
    child {node {g}
      child {node {k}} 
      child {node {l}}
    }
  };
\end{tikzpicture}
\end{center}
Die Buchstaben sind hier Stellvertreter für verschiedene vergleichbare Elemente, die auch nach der Eigenschaft aus Abschnitt \ref{eigBinBaum} angeordnet sind.

Bearbeiten Sie die nachfolgenden Aufgaben:

\paragraph{Aufgabe 1:}
\begin{mpc}{Die Blätter des Baums sind h, i, j, k und l.}
  \mpcl[1]{Falsch}
  \mpcl{Richtig}
\end{mpc}

\paragraph{Aufgabe 2:}
\begin{mpc}{In einem binären Suchbaum findet man das größte Elemente, indem man so lange den Kanten nach rechts folgt, bis man ein Blatt erreicht hat.}
  \mpcl{Falsch}
  \mpcl[1]{Richtig}
\end{mpc}
\paragraph{Aufgabe 3:}
\begin{mpc}{Die Nachfolger von b sind:}
    \mpcl[1]{d}
    \mpcl[1]{e}
    \mpcl{h}
    \mpcl{i}
\end{mpc}
\paragraph{Aufgabe 4:}
Geben Sie die Reihenfolge an, in der die Knoten beim \enquote{Inorder-Durchlauf} besucht werden. Denken Sie daran, dass die eingetragenen Buchstaben nur Platzhalter sind!
\end{Lernkontrolle}
\newpage
\begin{Loesungen}{Lösungen zu Kapitel 2:}
%
\end{Loesungen}
\paragraph{Aufgabe 2.1:}
\begin{enumerate}[(a)]
\item Zur 2: 5, 3, 2\\
  Zur 9: 5, 8, 9
\item Eine mögliche Darstellung für alle Suchdurchläufe:
\begin{center}
 \begin{tikzpicture}[level distance=13mm, level/.style={sibling distance=24mm/#1}, every node/.style={draw,circle,fill=white}]
\node[circle, draw] (root) {5}
  child {node {3}
    child {node {2}
      child {node {1}}
      child[missing] {node {x}}
      }
    child {node {4}}
    }
  child {node {8}
    child {node {7}
      child {node {6}}
      child[missing] {node {x}}
    }
    child {node {9}}
  };
  \end{tikzpicture}
\end{center}
Die Idee dahinter ist, dass man -- ausgehend von der betrachteten Zahl -- eine 
Linie nach rechts oder links zeichnet, die \enquote{getroffene} Zahl dort 
notiert und diesen Vorgang wiederholt, bis die Zahl gefunden wurde.
\end{enumerate}
\paragraph{Aufgabe 2.2:}
\begin{enumerate}[(a)]
\item 8 -- 7 -- 6 -- 9
\item Der linke Teilbaum besteht aus dem Knoten mit der Zahl 6, der rechte Teilbaum ist leer.
\item Ja, denn es kommt nicht darauf an, ob ein Knoten tatsächlich Nachfolger hat oder nicht.
%\item Die Aussage ist falsch. Der Teilbaum ist definiert als die Menge aller Knoten, die von einer gegebenen Wurzel aus erreichbar sind. Damit kann jeder Knoten nur Wurzel genau eines Teilbaums sein.
\end{enumerate}
\paragraph{Aufgabe 2.3:}
Bei einem gegebenen Teilbaum mit Wurzel $w$ sind alle Knoten in der linken Seite des Teilbaums \underbar{kleiner} als die Wurzel selbst. Die Knoten auf der rechten Seite dagegen sind alle \underbar{größer} als das Element in der Wurzel.

Verdeutlicht man sich, wie der Baum aufgebaut wurde, so wird diese Eigenschaft unmittelbar ersichtlich: Das mittlere Element (hier die 5) hat die Menge der Zahlen genau in zwei Hälften geteilt: eine mit kleineren und eine mit größeren Zahlen darin. Somit wird diese Zahl von uns als Wurzel festgelegt. Dieser Schritt wird nun für jede der Hälften wiederholt und jede der Zahlen wird damit zur Wurzel eines eigenen Teilbaums.
\paragraph{Aufgabe 2.4:}
Wir verdeutlichen uns den Ablauf zuerst anhand des Beispiels. Der Einfachheit halber (und da alle Anfangsbuchstaben verschieden sind), sind im Baum nur die Anfangsbuchstaben der jeweiligen Interpreten eingetragen.
\begin{center}
  \begin{longtable}{p{6cm}|p{6cm}}
    \begin{minipage}[b]{1.0\linewidth}
      Wir beginnen an der Wurzel. Da uns bekannt ist, dass alle Elemente links der Wurzel definitiv vor der Wurzel ausgegeben werden müssen, steigen wir in den linken Teilbaum ein.
    \end{minipage}
    &
    \footnotesize
    \begin{tikzpicture}[level distance=1cm, 
      level/.style={sibling distance=2cm/#1},
      every node/.style={draw,circle,fill=white, text centered}]
      \node[draw=red,fill=red!20,thick] (root) {I}
      child {node {D}
        child {node {B}
          child {node {A}}
          child[missing] {node {x}}
        }
        child {node {E}}
      }
      child {node {R}
        child {node {M}
          child {node {L}}
          child[missing] {node {x}}
        }
        child {node {T}
          child {node {S}}
          child[missing] {node {x}}
        }
      };

      \path[red,thick,draw,->] (root) -- (root-1);
    \end{tikzpicture}
    \\\hline
    \begin{minipage}[b]{1.0\linewidth}
      Wir betrachten erneut den linken Teilbaum, diesmal mit Knoten D als Wurzel (Begründung: s.o.) und setzen dieses Verfahren so lange fort, bis wir beim kleinsten Element angelangt sind. Dieses Element geben wir anschließend aus.
    \end{minipage}
    &
    \footnotesize
    \begin{tikzpicture}[level distance=1cm, 
      level/.style={sibling distance=2cm/#1},
      every node/.style={draw,circle,fill=white, text centered}]
      \node[draw=red,fill=red!20,thick] (root) {I}
      child {node[draw=red,fill=red!20,thick] {D}
        child {node[draw=red,fill=red!20,thick] {B}
          child {node[draw=blue,fill=blue!20,thick] {A}}
          child[missing] {node {x}}
        }
        child {node {E}}
      }
      child {node {R}
        child {node {M}
          child {node {L}}
          child[missing] {node {x}}
        }
        child {node {T}
          child {node {S}}
          child[missing] {node {x}}
        }
      };

      \path[red,thick,draw,->] (root) -- (root-1) -- (root-1-1) -- (root-1-1-1);
    \end{tikzpicture}
    \\\hline
    \begin{minipage}[b]{1.0\linewidth}
      Nun steigen wir eine Ebene im Baum auf. Wir wissen, dass die Elemente im rechten Teilbaum von B (falls er existiert) \underbar{größer} sind als B und demnach erst danach ausgegeben werden müssen. Alle kleineren Elemente sind bereits abgearbeitet, also können wir an dieser Stelle das B ausgeben.
    \end{minipage}
    &
    \footnotesize
    \begin{tikzpicture}[level distance=1cm, 
      level/.style={sibling distance=2cm/#1},
      every node/.style={draw,circle,fill=white, text centered}]
      \node[draw=red,fill=red!20,thick] (root) {I}
      child {node[draw=red,fill=red!20,thick] {D}
        child {node[draw=blue,fill=blue!20,thick] {B}
          child {node[draw=black!20,thick] {\color{black!20}A}}
          child[missing] {node {x}}
        }
        child {node {E}}
      }
      child {node {R}
        child {node {M}
          child {node {L}}
          child[missing] {node {x}}
        }
        child {node {T}
          child {node {S}}
          child[missing] {node {x}}
        }
      };

      \path[red,thick,draw,->] (root-1-1-1) -- (root-1-1);
    \end{tikzpicture}
    \\\hline
    \begin{minipage}[b]{1.0\linewidth}
      Wir steigen wiederum eine Ebene auf, da B's rechter Teilbaum leer ist, und geben das D aus. Danach steigen wir in den rechten Teilbaum von D ein, da sich dort alle Elemente befinden, die größer sind als D, aber kleiner als I.
    \end{minipage}
    &
    \footnotesize
    \begin{tikzpicture}[level distance=1cm, 
      level/.style={sibling distance=2cm/#1},
      every node/.style={draw,circle,fill=white, text centered}]
      \node[draw=red,fill=red!20,thick] (root) {I}
      child {node[draw=blue,fill=blue!20,thick] {D}
        child {node[draw=black!20,thick] {\color{black!20}B}
          child {node[draw=black!20,thick] {\color{black!20}A}}
          child[missing] {node {x}}
        }
        child {node[draw=red,fill=red!20,thick] {E}}
      }
      child {node {R}
        child {node {M}
          child {node {L}}
          child[missing] {node {x}}
        }
        child {node {T}
          child {node {S}}
          child[missing] {node {x}}
        }
      };

      \path[red,thick,draw,->] (root-1-1) -- (root-1);
      \path[red,thick,draw,->] (root-1) -- (root-1-2);
      \path[black!20,thick,draw] (root-1-1-1) -- (root-1-1);
    \end{tikzpicture}
    \\\hline
    \begin{minipage}[b]{1.0\linewidth}
      Anschließend geben wir das E aus, da es sich um ein Blatt handelt und sowohl rechter als auch linker Teilbaum leer sind.
    \end{minipage}
    &
    \footnotesize
    \begin{tikzpicture}[level distance=1cm, 
      level/.style={sibling distance=2cm/#1},
      every node/.style={draw,circle,fill=white, text centered}]
      \node[draw=red,fill=red!20,thick] (root) {I}
      child {node[draw=black!20,thick] {\color{black!20}D}
        child {node[draw=black!20,thick] {\color{black!20}B}
          child {node[draw=black!20,thick] {\color{black!20}A}}
          child[missing] {node {x}}
        }
        child {node[draw=blue,fill=blue!20,thick] {E}}
      }
      child {node {R}
        child {node {M}
          child {node {L}}
          child[missing] {node {x}}
        }
        child {node {T}
          child {node {S}}
          child[missing] {node {x}}
        }
      };
      \path[black!20,thick,draw] (root-1-1-1) -- (root-1-1) -- (root-1);
      %\path[red,thick,draw,->] (root-1-2) -- (root-1) -- (root);
    \end{tikzpicture}
    \\\hline
    \begin{minipage}[b]{1.0\linewidth}
      Da nun alle Knoten des linken Teilbaums der Wurzel I ausgegeben wurden (und somit alle Elemente, die kleiner sind als I), steigen wir auf bis zur Wurzel und geben diese aus.
    \end{minipage}
    &
    \footnotesize
    \begin{tikzpicture}[level distance=1cm, 
      level/.style={sibling distance=2cm/#1},
      every node/.style={draw,circle,fill=white, text centered}]
      \node[draw=blue,fill=blue!20,thick] (root) {I}
      child {node[draw=black!20,thick] {\color{black!20}D}
        child {node[draw=black!20,thick] {\color{black!20}B}
          child {node[draw=black!20,thick] {\color{black!20}A}}
          child[missing] {node {x}}
        }
        child {node[draw=black!20,thick] {\color{black!20}E}}
      }
      child {node {R}
        child {node {M}
          child {node {L}}
          child[missing] {node {x}}
        }
        child {node {T}
          child {node {S}}
          child[missing] {node {x}}
        }
      };

      \path[red,thick,draw,->] (root-1-2) -- (root-1) -- (root);
      \path[black!20,thick,draw] (root-1-1-1) -- (root-1-1) -- (root-1);
    \end{tikzpicture}
    \\\hline
  \begin{minipage}[b]{1.0\linewidth}
      Anschließend müssen die Knoten des rechten Teilbaums ausgegeben werden. Wir steigen in den rechten Teilbaum ein, hin zum R.
    \end{minipage}
    &
    \footnotesize
    \begin{tikzpicture}[level distance=1cm, 
      level/.style={sibling distance=2cm/#1},
      every node/.style={draw,circle,fill=white, text centered}]
      \node[draw=black!20,thick] (root) {\color{black!20}I}
      child {node[draw=black!20,thick] {\color{black!20}D}
        child {node[draw=black!20,thick] {\color{black!20}B}
          child {node[draw=black!20,thick] {\color{black!20}A}}
          child[missing] {node {x}}
        }
        child {node[draw=black!20,thick] {\color{black!20}E}}
      }
      child {node[draw=red,fill=red!20,thick] {R}
        child {node {M}
          child {node {L}}
          child[missing] {node {x}}
        }
        child {node {T}
          child {node {S}}
          child[missing] {node {x}}
        }
      };

      \path[red,thick,draw,->] (root) -- (root-2);
      \path[black!20,thick,draw] (root-1-1-1) -- (root-1-1) -- (root-1) -- (root-1-2) -- (root-1) -- (root);
    \end{tikzpicture}
    \\\hline
  \begin{minipage}[b]{1.0\linewidth}
      An dieser Stelle verdeutlichen wir uns nochmals die Eigenschaft aus \ref{eigBinBaum} - alle Knoten im rechten Teilbaum von I sind \underbar{größer} als I. Für R gilt wiederum: Alle Knoten im linken Teilbaum von  R sind \underbar{kleiner} als R, alle im rechten Teilbaum \underbar{größer}. Also steigen wir als nächstes in den \underbar{linken} Teilbaum von R hinab. Dort verfahren wir nach dem gleichen Schema.
    \end{minipage} 
    &
    \footnotesize
    \begin{tikzpicture}[level distance=1cm, 
      level/.style={sibling distance=2cm/#1},
      every node/.style={draw,circle,fill=white, text centered}]
      \node[draw=black!20,thick] (root) {\color{black!20}I}
      child {node[draw=black!20,thick] {\color{black!20}D}
        child {node[draw=black!20,thick] {\color{black!20}B}
          child {node[draw=black!20,thick] {\color{black!20}A}}
          child[missing] {node {x}}
        }
        child {node[draw=black!20,thick] {\color{black!20}E}}
      }
      child {node[draw=red,fill=red!20,thick] {R}
        child {node[draw=red,fill=red!20,thick] {M}
          child {node[draw=red,fill=red!20,thick] {L}}
          child[missing] {node {x}}
        }
        child {node {T}
          child {node {S}}
          child[missing] {node {x}}
        }
      };

      \path[red,thick,draw,->] (root-2) -- (root-2-1) -- (root-2-1-1); 
      \path[black!20,thick,draw] (root-1-1-1) -- (root-1-1) -- (root-1) -- (root-1-2) -- (root-1) -- (root) -- (root-2);
    \end{tikzpicture}
    \\\hline
  \begin{minipage}[b]{1.0\linewidth}
    Da wir nun bei einem Blatt angekommen sind, geben wir L aus und steigen eine Ebene im Baum auf zum M.
  \end{minipage} 
    &
    \footnotesize
    \begin{tikzpicture}[level distance=1cm, 
      level/.style={sibling distance=2cm/#1},
      every node/.style={draw,circle,fill=white, text centered}]
      \node[draw=black!20,thick] (root) {\color{black!20}I}
      child {node[draw=black!20,thick] {\color{black!20}D}
        child {node[draw=black!20,thick] {\color{black!20}B}
          child {node[draw=black!20,thick] {\color{black!20}A}}
          child[missing] {node {x}}
        }
        child {node[draw=black!20,thick] {\color{black!20}E}}
      }
      child {node[draw=red,fill=red!20,thick] {R}
        child {node[draw=red,fill=red!20,thick] {M}
          child {node[draw=blue,fill=blue!20,thick] {L}}
          child[missing] {node {x}}
        }
        child {node {T}
          child {node {S}}
          child[missing] {node {x}}
        }
      };

      \path[red,thick,draw,->] (root-2-1-1) -- (root-2-1); 
      \path[black!20,thick,draw] (root-1-1-1) -- (root-1-1) -- (root-1) -- (root-1-2) -- (root-1) -- (root) -- (root-2);
    \end{tikzpicture}
    \\\hline
  \begin{minipage}[b]{1.0\linewidth}
    M's rechter Teilbaum ist leer, demnach geben wir M aus und steigen auf zum R.
  \end{minipage} 
    &
    \footnotesize
    \begin{tikzpicture}[level distance=1cm, 
      level/.style={sibling distance=2cm/#1},
      every node/.style={draw,circle,fill=white, text centered}]
      \node[draw=black!20,thick] (root) {\color{black!20}I}
      child {node[draw=black!20,thick] {\color{black!20}D}
        child {node[draw=black!20,thick] {\color{black!20}B}
          child {node[draw=black!20,thick] {\color{black!20}A}}
          child[missing] {node {x}}
        }
        child {node[draw=black!20,thick] {\color{black!20}E}}
      }
      child {node[draw=red,fill=red!20,thick] {R}
        child {node[draw=blue,fill=blue!20,thick] {M}
          child {node[draw=black!20,thick] {\color{black!20}L}}
          child[missing] {node {x}}
        }
        child {node {T}
          child {node {S}}
          child[missing] {node {x}}
        }
      };
      
      \path[black!20,thick,draw] (root-1-1-1) -- (root-1-1) -- (root-1) -- (root-1-2) -- (root-1) -- (root) -- (root-2) -- (root-2-1) -- (root-2-1-1);
      \path[red,thick,draw,->] (root-2-1) -- (root-2); 
      
    \end{tikzpicture}
    \\\hline
  \begin{minipage}[b]{1.0\linewidth}
    Da alle Elemente im linken Teilbaum von R ausgegeben wurden, geben wir R aus und steigen danach in den rechten Teilbaum von R ein.
  \end{minipage} 
    &
    \footnotesize
    \begin{tikzpicture}[level distance=1cm, 
      level/.style={sibling distance=2cm/#1},
      every node/.style={draw,circle,fill=white, text centered}]
      \node[draw=black!20,thick] (root) {\color{black!20}I}
      child {node[draw=black!20,thick] {\color{black!20}D}
        child {node[draw=black!20,thick] {\color{black!20}B}
          child {node[draw=black!20,thick] {\color{black!20}A}}
          child[missing] {node {x}}
        }
        child {node[draw=black!20,thick] {\color{black!20}E}}
      }
      child {node[draw=blue,fill=blue!20,thick] {R}
        child {node[draw=black!20,thick] {\color{black!20}M}
          child {node[draw=black!20,thick] {\color{black!20}L}}
          child[missing] {node {x}}
        }
        child {node[draw=red,fill=red!20,thick] {T}
          child {node[draw=red,fill=red!20,thick] {S}}
          child[missing] {node {x}}
        }
      };
      
      \path[black!20,thick,draw] (root-1-1-1) -- (root-1-1) -- (root-1) -- (root-1-2) -- (root-1) -- (root) -- (root-2) -- (root-2-1) -- (root-2-1-1);
      \path[red,thick,draw,->] (root-2) -- (root-2-2) -- (root-2-2-1); 
    \end{tikzpicture}
    \\\hline
  \begin{minipage}[b]{1.0\linewidth}
    Wir kommen beim Blatt S an, geben es aus und steigen zum letzten verbleibenden Knoten T auf.
  \end{minipage} 
    &
    \footnotesize
    \begin{tikzpicture}[level distance=1cm, 
      level/.style={sibling distance=2cm/#1},
      every node/.style={draw,circle,fill=white, text centered}]
      \node[draw=black!20,thick] (root) {\color{black!20}I}
      child {node[draw=black!20,thick] {\color{black!20}D}
        child {node[draw=black!20,thick] {\color{black!20}B}
          child {node[draw=black!20,thick] {\color{black!20}A}}
          child[missing] {node {x}}
        }
        child {node[draw=black!20,thick] {\color{black!20}E}}
      }
      child {node[draw=black!20,thick] {\color{black!20}R}
        child {node[draw=black!20,thick] {\color{black!20}M}
          child {node[draw=black!20,thick] {\color{black!20}L}}
          child[missing] {node {x}}
        }
        child {node[draw=red,fill=red!20,thick] {T}
          child {node[draw=blue,fill=blue!20,thick] {S}}
          child[missing] {node {x}}
        }
      };
      
      \path[black!20,thick,draw] (root-1-1-1) -- (root-1-1) -- (root-1) -- (root-1-2) -- (root-1) -- (root) -- (root-2) -- (root-2-1) -- (root-2-1-1);
      \path[red,thick,draw,->] (root-2-2-1) -- (root-2-2); 
    \end{tikzpicture}
    \\\hline
  \begin{minipage}[b]{1.0\linewidth}
    Anschließen geben wir T aus. Da T's rechter Teilbaum leer ist, beenden wir die Ausgabe an dieser Stelle.
  \end{minipage} 
    &
    \footnotesize
    \begin{tikzpicture}[level distance=1cm, 
      level/.style={sibling distance=2cm/#1},
      every node/.style={draw,circle,fill=white, text centered}]
      \node[draw=black!20,thick] (root) {\color{black!20}I}
      child {node[draw=black!20,thick] {\color{black!20}D}
        child {node[draw=black!20,thick] {\color{black!20}B}
          child {node[draw=black!20,thick] {\color{black!20}A}}
          child[missing] {node {x}}
        }
        child {node[draw=black!20,thick] {\color{black!20}E}}
      }
      child {node[draw=black!20,thick] {\color{black!20}R}
        child {node[draw=black!20,thick] {\color{black!20}M}
          child {node[draw=black!20,thick] {\color{black!20}L}}
          child[missing] {node {x}}
        }
        child {node[draw=blue,fill=blue!20,thick] {T}
          child {node[draw=black!20,thick] {\color{black!20}S}}
          child[missing] {node {x}}
        }
      };
      
      \path[black!20,thick,draw] (root-1-1-1) -- (root-1-1) -- (root-1) -- (root-1-2) -- (root-1) -- (root) -- (root-2) -- (root-2-1) -- (root-2-1-1) -- (root-2-1) -- (root-2) -- (root-2-2) -- (root-2-2-1);
      %\path[red,thick,draw,->] (root-2-2-1) -- (root-2-2); 
    \end{tikzpicture}
    \\\hline
  \end{longtable}
\end{center}
Die endgültige Ausgabe lautet demnach:
\begin{center}
  A, B, D, E, I, L, M, R, S, T.
\end{center}
Wir können den Algorithmus nun in eine umgangssprachliche Form bringen:
\begin{itemize}
\item Steige an der Wurzel in den Baum ein
\item Wiederhole für jeden Knoten -- von der Wurzel aus -- folgende Schritte:
  \begin{itemize}
  \item Steige in den linken Teilbaum ein und beginne für jeden Knoten diese Abfolge von Schritten. Ist der linke Teilbaum leer, gehe zum nächsten Schritt.
  \item Gib den Knoten aus.
  \item Steige in den rechten Teilbaum ein und beginne für jeden Knoten diese Abfolge von Schritten.
  \end{itemize}
\end{itemize}
\paragraph{Lernkontrolle}
  \begin{center}
    \begin{tikzpicture}[level distance=1.1cm, 
      level/.style={sibling distance=5cm/#1},
      every node/.style={draw,circle,fill=white, text centered}]
      \node (root) {a}
      child {node {b}
        child {node {d}
          child {node {h}}
          child {node {i}}
        }
        child {node {e}}
      }
      child {node {c}
        child {node {f}
          child[missing] {node {x}}
      child {node {j}}
    }
    child {node {g}
      child {node {k}} 
      child {node {l}}
    }
  };
\end{tikzpicture}
\end{center}
Die Buchstaben sind hier Stellvertreter für verschiedene vergleichbare Elemente, die auch nach der Eigenschaft aus Abschnitt \ref{eigBinBaum} angeordnet sind.

Bearbeiten Sie die nachfolgenden Aufgaben:

\paragraph{Aufgabe 1:}
\begin{mpc}[1]{Die Blätter des Baums sind h, i, j, k und l.}
  \mpcl[1]{Falsch -- e fehlt.}
  \mpcl{Richtig}
\end{mpc}

\paragraph{Aufgabe 2:}
\begin{mpc}[1]{In einem binären Suchbaum findet man das größte Elemente, in dem man so lange den Kanten nach rechts folgt, bis man ein Blatt erreicht hat.}
  \mpcl{Falsch}
  \mpcl[1]{Richtig}
\end{mpc}
\paragraph{Aufgabe 3:}
\begin{mpc}[1]{Die Nachfolger von b sind:}
    \mpcl[1]{d}
    \mpcl[1]{e}
    \mpcl{h}
    \mpcl{i}
\end{mpc}
\paragraph{Aufgabe 4:}
\begin{center}
  h, d, i, b, e, a, f, j, c, k, g, l.
\end{center}

%%% Local Variables: 
%%% mode: latex
%%% TeX-master: "Vorlage"
%%% End: 
